Ext.define('DSS.component.MessageEditor', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    height : 140,
    txtReceiver : null,
    txtSubject : null,
    txtBody : null,
    padding : 5,
    constructor : function(config) {

        this.txtReceiver = Ext.create('Ext.form.field.Text', {
            fieldLabel : 'Empf&auml;nger',
            allowBlank : false,
            width : 600,
            labelWidth : 84,
            regex : /\b[A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i,
            regexText : 'Die Emailadresse ist fehlerhaft',
            blankText : 'Die Emailadresse muss ausgef&uuml;llt werden',
            invalidText : 'Die Emailadresse muss ausgef&uuml;llt werden'
        });

        this.txtSubject = Ext.create('DSS.component.Textedit', {
            fieldLabel : 'Betreff',
            allowBlank : false,
            width : 600,
            labelWidth : 84,
            blankText : 'Betreff muss ausgef&uuml;llt werden',
            invalidText : 'Betreff muss ausgef&uuml;llt werden'
        });

        this.txtBody = Ext.create('DSS.component.TextAreaedit', {
            fieldLabel : 'Inhalt',
            allowBlank : false,
            width : 600,
            height : 60,
            labelWidth : 84,
            blankText : 'Inhalt muss ausgef&uuml;llt werden',
            invalidText : 'Inhalt muss ausgef&uuml;llt werden'
        });
        var oControlGroup = Ext.create('Ext.form.FieldSet', {
            title : config.title,
            width : "100%",
            items : [ this.txtReceiver, this.txtSubject, this.txtBody ]
        });

        Ext.apply(this, {
            items : [ oControlGroup ]
        });
        this.callParent(arguments);
    },
    reset : function() {
        this.txtBody.reset();
        this.txtSubject.reset();
        this.txtReceiver.reset();
    },
    setValue : function(value) {
        // messageType:"email",
        this.txtBody.setValue(value.message);
        this.txtSubject.setValue(value.subject);
        this.txtReceiver.setValue(value.receiver);
    },
    isValid : function() {
        if (!this.txtBody.isValid())
            return false;
        if (!this.txtSubject.isValid())
            return false;
        if (!this.txtReceiver.isValid())
            return false;
        return true;
    },
    getValue : function() {
        var oObject = {};
        oObject.messageType = 'email';
        oObject.receiver = this.txtReceiver.getValue();
        oObject.subject = this.txtSubject.getValue();
        oObject.message = this.txtBody.getValue();
        return oObject;
    }
});
